/* $Id: libvxvmsc.h,v 1.7.106.1 2005/07/13 20:19:00 himanshu Exp $ */
/* #ident "$Source: /project/unixvm-cvs/src/sol/lib/vxvm/libvxvmsc/libvxvmsc.h,v $ $Revision: 1.7.106.1 $" */

/*
 * $Copyright: Copyright (c) 2009 Symantec Corporation.
 * All rights reserved.
 *
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
 * SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
 * WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
 *
 * The Licensed Software and Documentation are deemed to be commercial
 * computer software as defined in FAR 12.212 and subject to restricted
 * rights as defined in FAR Section 52.227-19 "Commercial Computer
 * Software - Restricted Rights" and DFARS 227.7202, "Rights in
 * Commercial Computer Software or Commercial Computer Software
 * Documentation", as applicable, and any successor regulations. Any use,
 * modification, reproduction release, performance, display or disclosure
 * of the Licensed Software and Documentation by the U.S. Government
 * shall be solely in accordance with the terms of this Agreement.  $
 */

#ifndef _LIBVXVMSC_H
#define _LIBVXVMSC_H

#include <sys/types.h>
#include <vxvm/vxtypes.h>
#include <sys/stat.h>
#include <sys/param.h>

#define	LIBVXVM_MAJOR_VERSION	1
#define	LIBVXVM_MINOR_VERSION	1
#define	LIBVXVM_MAKE_VERSION(maj, min)	((maj) << 8 | (min))
#define	LIBVXVM_GET_MAJOR_VERSION(ver)	((ver) >> 8)
#define	LIBVXVM_GET_MINOR_VERSION(ver)	((ver) & 0xff)

#define	IMPORT_OPT_FORCE	0x1
#define	IMPORT_OPT_TEMPNAME	0x2
#define	IMPORT_OPT_CLEARIMPORT	0x4
#define	IMPORT_OPT_REMINOR	0x8
#define	IMPORT_OPT_MASK		0xf

#define	LIBVXVM_NAME_SIZE	1
#define	LIBVXVM_PATH_SIZE	2
#define	LIBVXVM_DEVNAME_SZ	3

#define	LIBVXVM_DG_GD_ENABLE	1
#define	LIBVXVM_DG_GD_DISABLE	2

typedef vx_u32_t	vm_major_t;
typedef vx_u32_t	vm_minor_t;
typedef char		vm_name_t[];
typedef char		vm_path_t[];

#if defined(__STDC__)

extern int libvxvm_get_version(int version);
extern int libvxvm_get_conf(int param);
extern int libvxvm_get_dgs(int len, vm_name_t namep[]);
extern int libvxvm_get_dginfo(vm_name_t dgname, vm_name_t dgid,
	vm_major_t *majorp, vm_minor_t *minorp,
	vx_u32_t *maxvolp, vx_u32_t *nvolp);
extern int libvxvm_get_disks(vm_name_t dgname, int len, vm_path_t pathp[]);
extern int libvxvm_get_volumes(vm_name_t dgname, int len, vm_name_t namep[]);
extern int libvxvm_get_volinfo(vm_name_t dgname, vm_name_t volname,
	struct stat *statp);
extern int libvxvm_import_dg(vm_name_t dgname, vm_name_t newname,
	vx_u32_t flags, vm_minor_t newminor);
extern int libvxvm_deport_dg(vm_name_t dgname, vm_name_t newname,
	vm_name_t newhostid);
extern int libvxvm_get_subpaths(char *dmp_nodename, int *numpaths,
						char **pathnamep);
extern int libvxvm_dg_set_gd_link(char *dgname, int flag);
extern int libvxvm_dg_gd_linked(char *dgname);

#else   /* __STDC__ */

extern int libvxvm_get_version();
extern int libvxvm_get_conf();
extern int libvxvm_get_dgs();
extern int libvxvm_get_dginfo();
extern int libvxvm_get_disks();
extern int libvxvm_get_volumes();
extern int libvxvm_get_volinfo();
extern int libvxvm_import_dg();
extern int libvxvm_deport_dg();
extern int libvxvm_get_subpaths();
extern int libvxvm_dg_set_gd_link();
extern int libvxvm_dg_gd_linked();

#endif  /* __STDC__ */

#endif  /* _LIBVXVMSC_H */
