#
# $Id: Egettxt.pm,v 1.2.2.1 2003/06/06 16:44:09 rohit Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/sdscvt/lib/Egettxt.pm,v $"
#
# $Copyrights: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

use strict;

package Egettxt;
require Exporter;

use vars qw(@ISA @EXPORT $egettxt_available $egettxt_path $terminals $prog);

@ISA = qw(Exporter);
@EXPORT = qw(&egettxt &Die &Warning &Terminal);

$egettxt_path = "/etc/vx/bin/egettxt";

BEGIN { $prog = $0; $prog =~ s,^.*/,,; }

sub egettxt {
	my ($msgid, $msg, $args) = @_;

	if ($egettxt_available) {
		$ENV{'prog'} = $prog;
		$ENV{$_} = $args->{$_} for keys %{$args};
		my $result = system ($egettxt_path, $msg, $msgid);
		# undef $ENV{$_} for keys %{$args};
		if ($result / 256 != 0) {
			$egettxt_available = 0;
			print STDERR "$0: warning: egettxt failed, no translations possible.\n";
		}
	}
	# don't put this in an else clause, it could run after egettxt fails
	if (not $egettxt_available) {
		$msg =~ s/\$($_\b|\{$_\})/$args->{$_}/g for keys %{$args};
		print STDERR $msg, "\n";
	}
}

sub Die {
	egettxt(@_);
	exit 1;
}

sub Warning {
	egettxt(@_);
}

#
# A terminal error will kill the patient eventually, but doesn't prevent
# the program from limping along to try and report more problems so they
# can be solved all at once.
#
$terminals = 0;
sub Terminal {
	egettxt(@_);
	++$terminals;
}

# Cause the program to exit with an error if there were terminal errors.
END {
	$? = 1 if $terminals;
}

$egettxt_available = 1;
