#
# $Id: OrElse.pm,v 1.2.2.1 2003/06/06 16:44:10 rohit Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/sdscvt/lib/OrElse.pm,v $"
#
# $Copyrights: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

use strict;

package OrElse;

use Egettxt;

require Exporter;

use vars qw(@ISA @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw(&xopen &xmkdir &xchdir);

use Symbol 'qualify_to_ref';

sub xopen(*;$) {
	my $fh = qualify_to_ref(shift, caller);
	my $p = shift || $$$fh;

	CORE::open($$fh, $p) or Die('vmsolsds:100', '$prog: open: $path: $strerror',
				{ 'path' => $p, 'strerror' => "$!" })
}

sub xmkdir($$) {
	my ($p, $m) = @_;

	CORE::mkdir($p, $m) or Die('vmsolsds:101', '$prog: mkdir: $path: $strerror',
				{ 'path' => $p, 'strerror' => "$!" })
}

sub xchdir($) {
	my ($p) = @_;

	CORE::chdir($p) or Die('vmsolsds:102', '$prog: chdir: $path: $strerror',
				{ 'path' => $p, 'strerror' => "$!" })
}

1;
