#
# $Id: Registered.pm,v 1.2.2.1 2003/06/06 16:44:10 rohit Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/sdscvt/lib/Registered.pm,v $"
#
# $Copyrights: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

package Registered;

sub Registry { undef }

sub RegistryKey { 'name' }

sub RegistryRenew { 1 }

sub Register {
	my $self = shift;

	$self->Registry->{$self->{$self->RegistryKey}} = $self
}

sub Unregister {
	my $self = shift;

	undef $self->Registry->{$self->{$self->RegistryKey}}
}

sub Rekey {
	my $self = shift;
	my $newkey = shift;

	$self->Unregister;
	die if $self->Find($newkey);
	$self->{$self->RegistryKey} = $newkey;
	$self->Register;
}

sub Find {
	my $type = shift;
	my $name = shift;

	$type->Registry->{$name}
}

sub All {
	my $type = shift;

	grep { (ref $_) =~ /^$type/ } values %{$type->Registry};
}

sub new {
	my $type = shift;
	my $ident = shift;

	my $self = $type->Find($ident);
	if ($self and not $type->RegistryRenew) {
		die "can't create new $type: " . $self->RegistryKey .
			" `$ident' (a " . (ref $self) . ") already exists";
	}
	if (not defined $self) {
		$self = bless { $type->RegistryKey => $ident }, $type;
		$self->Register();
	}
	$self;
}
1;
