#!/bin/ksh -p
# $Id: libconv.ksh,v 1.2.2.1 2003/06/06 16:44:11 rohit Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/sdscvt/lib/libconv.ksh,v $"
#
# $Copyrights: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

#
# getmetasets -all - print the list of metasets 
#		-all prints all of them including those not owned by us
#

get_metasets() {

	get_meta_all=no
	if [ "$#" -eq "1" -a "X$1" = "X-all" ] ; then
		get_meta_all=yes
	elif [ "$#" -eq "0" ] ; then
		: # do the default thing
	else
		echo "get_metasets help... $@"
		exit 0
	fi

	get_meta_HOSTNAME=`uname -n | sed -e 's/^\(.................\).*/\1/`
	get_meta_list=""
	for get_meta_diskset in `LC_ALL=C metaset 2> /dev/null | grep Set | \
		sed -e 's/Set name = \([^,]*\),.*/\1/'`
	do
		TMP=`LC_ALL=C metaset -s $get_meta_diskset | \
			grep "$get_meta_HOSTNAME[ 	]*Yes"`
		if [ "X$get_meta_all" = "Xno" -a -z "$TMP" ] ; then
			# we do not own it next
			continue
		fi

		# we own it so we can look at it.
		get_meta_list="$get_meta_list $get_meta_diskset"
	done
	
	echo "$get_meta_list"
}
