#!/usr/bin/perl
# $Id: es_devfs.pl,v 1.1.4.1.24.1 2005/11/08 19:45:18 vammula Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/vxvm/esd/es_devfs.pl,v $"


#
# $Copyright: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

# Script to handle EC_devfs sysevents
use strict;

# include the path for ESevents.ph perl header file
push(@INC,'/etc/vx/es_scripts');

require 'es_events.ph';

# definitions from sys/socket.h, reproduced here to remove dependency
# with existence of sys/socket.ph
my($af_unix, $pf_unix, $sock_stream);
$af_unix = 1;
$pf_unix = $af_unix;
$sock_stream = 2;

sub plat_sol_x86
{
   my  $res;
   my $a = `uname -a`;
   if ($a =~ /SunOS/ && $a =~ /i386/) {$res = 1}
}


# function to return an error message to the caller
sub do_print_error
{
	my ($errmsg);

	$errmsg = shift(@_);
	exit(3);
}


# function to establish connection with Event source daemon,
# send the event information and return the response obtained 
# from the daemon back to the caller 
# IN: 	event name, parameter list
# OUT:	return value, message length, message
sub do_ipc
{
	my($event, @params, $hostname, $name, $aliases, $type, $len, $addr, $temp);
	my($sockaddr, $proto, $dest, $smsg, $nparam, $rmsg, $param, $res, $mlen, $msg);
	my $len_and_param;
	my $sol_x86 = &plat_sol_x86;

	# event information, event name and parameter list
	$event = shift(@_);
	@params = @_;

	$sockaddr = 'S a108';

	# fill the sockaddr structure
	$dest = pack($sockaddr, $af_unix, &ES_SOCK_FILE);

	# establish connection with server
	socket(S, $pf_unix, $sock_stream, 0) || &do_print_error("socket: $!");
	connect(S, $dest)|| &do_print_error("connect: $!");

	select(S);
	$| = 1;
	select(stdout);

	# send the event information
	$nparam = $#params + 1;
	$smsg = pack('a13 x3 i', $event, $nparam);
	syswrite(S, $smsg, length($smsg));

	while($param = shift(@params)) {
		unless (defined($sol_x86)) { # This is the case of solaris SPARC
		   $len = pack('i', length($param));
		   syswrite(S, $len, length($len));
		   syswrite(S, $param, length($param));
		} else { # This is the case of solaris x86
		   $len_and_param = pack('i a*', length($param), $param);
		   syswrite(S, $len_and_param, length($len_and_param));
		}
	}

	# read the response from the server 
	$rmsg = pack('i2', 0, 0);
	sysread(S, $rmsg, length($rmsg));
	($res, $mlen) = unpack('i2', $rmsg);
	if ($mlen > 0) {
		while(sysread(S, $temp, $mlen)) {
			$msg = $temp;
		}
	}

	# close connection and return response to the caller
	shutdown(S, 2);
	($res, $mlen, $msg);
}


# Main - send the post attach event to the event source daemon
my(@list, $ret, $len, $str);

@list = @ARGV;

($ret, $len, $str) = &do_ipc(&POST_ATTACH, @list);
if ($ret == 1) {
	exit(0);
}
else {
	exit(3);
}
