#!/bin/ksh
# $Id: es_uninstall.sh,v 1.1.4.3.24.1 2004/07/29 21:58:34 hhorn Exp $
#ident "$Source: /project/unixvm-cvs/src/sol/cmd/vxvm/esd/es_uninstall.sh,v $"

#
# $Copyright: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

# Script to uninstall handler for EC_devfs sysevents and RCM events

# default values
SH=/usr/bin/perl
DEVFS_SCRIPT=/etc/vx/es_scripts/es_devfs.pl
DEVFS_CONFIG=/etc/sysevent/config/EC_devfs,sysevent.conf
RCM_SCRIPT=es_rcm.pl


# function to uninstall sysvent handlers
function uninstall_sysevent
{
	#echo "Uninstalling handler for EC_devfs events"
	case `uname -r` in
		5.8)
			rm $DEVFS_CONFIG
			if [ ! $? -eq 0 ]
			then
				ugettxt -s ERROR "Unable to uninstall DEVFS script" vxvmshm:3310
				return
			fi

			pkill -HUP syseventd
			;;

		5.9)
			syseventadm remove -c EC_devfs $SH $DEVFS_SCRIPT
			if [ ! $? -eq 0 ]
			then
				ugettxt -s ERROR "Unable to uninstall DEVFS script" vxvmshm:3310
				return
			fi

			syseventadm restart
			;;

		5.10)
			syseventadm remove -c EC_devfs $SH $DEVFS_SCRIPT
			if [ ! $? -eq 0 ]
			then
				ugettxt -s ERROR "Unable to uninstall DEVFS script" vxvmshm:3310
				return
			fi

			syseventadm restart
			;;

		  *)
			;;
	esac
}


# function to unistall RCM script
function uninstall_rcmevent
{
	#echo "Uninstalling RCM script $script"
	rm /usr/lib/rcm/scripts/$RCM_SCRIPT
	if [ ! $? -eq 0 ]
	then
		ugettxt -s ERROR "Unable to uninstall RCM script" vxvmshm:3311
		return
	fi

	pkill -HUP -x -u root rcm_daemon
}


# Main
case $1 in
        "sysevent")
                uninstall_sysevent
                ;;
        "rcmevent")
                uninstall_rcmevent
                ;;
        "all")
                uninstall_sysevent
                uninstall_rcmevent
                ;;
        *)
                ugettxt -s INFO "Script to uninstall handler for EC_devfs sysevent and RCM script" vxvmshm:3231
                echo "Usage:  $0 <sysevent | rcmevent | all>"
                ;;
esac
